package com.ruoyi.project.sems.controller;

import java.io.FileOutputStream;
import java.io.IOException;
import java.io.OutputStream;
import java.text.SimpleDateFormat;
import java.util.ArrayList;
import java.util.List;

import com.alibaba.fastjson.JSON;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.ruoyi.common.utils.DateUtils;
import com.ruoyi.common.utils.file.ExcelUtils;
import com.ruoyi.project.sems.domain.*;
import com.ruoyi.project.sems.service.ITSpecCheckService;
import com.ruoyi.project.system.domain.SysDept;
import com.ruoyi.project.system.domain.SysDictData;
import com.ruoyi.project.system.service.ISysDeptService;
import com.ruoyi.project.system.service.ISysDictTypeService;
import org.apache.poi.ss.usermodel.*;
import org.apache.poi.xssf.streaming.SXSSFWorkbook;
import org.springframework.security.access.prepost.PreAuthorize;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;
import com.ruoyi.framework.aspectj.lang.annotation.Log;
import com.ruoyi.framework.aspectj.lang.enums.BusinessType;
import com.ruoyi.project.sems.service.ITSpecdevGlService;
import com.ruoyi.framework.web.controller.BaseController;
import com.ruoyi.framework.web.domain.AjaxResult;
import com.ruoyi.common.utils.poi.ExcelUtil;
import com.ruoyi.framework.web.page.TableDataInfo;
import org.springframework.web.multipart.MultipartFile;

/**
 * 特种设备锅炉台账Controller
 *
 * @author ruoyi
 * @date 2021-07-21
 */
@RestController
@RequestMapping("/sems/specGl")
public class TSpecdevGlController extends BaseController
{
    @Autowired
    private ITSpecdevGlService tSpecdevGlService;
    @Autowired
    private ITSpecCheckService tSpecCheckService;
    @Autowired
    private ISysDeptService iSysDeptService;
    @Autowired
    private ISysDictTypeService iSysDictTypeService;
    /**
     * 查询特种设备锅炉台账列表
     */
    @PreAuthorize("@ss.hasPermi('sems:specGl:list')")
    @GetMapping("/list")
    public TableDataInfo list(TSpecdevGl tSpecdevGl)
    {
        startPage();
        List<TSpecdevGl> list = tSpecdevGlService.selectTSpecdevGlList(tSpecdevGl);
        return getDataTable(list);
    }

    /**
     * 导出特种设备锅炉台账列表
     */
    @PreAuthorize("@ss.hasPermi('sems:specGl:export')")
    @Log(title = "特种设备锅炉台账", businessType = BusinessType.EXPORT)
    @GetMapping("/export")
    public AjaxResult export(TSpecdevGl tSpecdevGl)
    {
        List<TSpecdevGl> list = tSpecdevGlService.selectTSpecdevGlList(tSpecdevGl);
        ExcelUtil<TSpecdevGl> util = new ExcelUtil<TSpecdevGl>(TSpecdevGl.class);
        return util.exportExcel(list, "specGl");
    }

    /**
     * 获取特种设备锅炉台账详细信息
     */
    @PreAuthorize("@ss.hasPermi('sems:specGl:query')")
    @GetMapping(value = "/{id}")
    public AjaxResult getInfo(@PathVariable("id") Long id)
    {
        return AjaxResult.success(tSpecdevGlService.selectTSpecdevGlById(id));
    }

    /**
     * 新增特种设备锅炉台账
     */
    @PreAuthorize("@ss.hasPermi('sems:specGl:add')")
    @Log(title = "特种设备锅炉台账", businessType = BusinessType.INSERT)
    @PostMapping
    public AjaxResult add(@RequestBody TSpecdevGl tSpecdevGl)
    {
        return toAjax(tSpecdevGlService.insertTSpecdevGl(tSpecdevGl));
    }

    /**
     * 修改特种设备锅炉台账
     */
    @PreAuthorize("@ss.hasPermi('sems:specGl:edit')")
    @Log(title = "特种设备锅炉台账", businessType = BusinessType.UPDATE)
    @PutMapping
    public AjaxResult edit(@RequestBody TSpecdevGl tSpecdevGl)
    {
        TSpecdevGl old = tSpecdevGlService.selectTSpecdevGlById(tSpecdevGl.getId());
        if (!old.getReportNo().equals(tSpecdevGl.getReportNo())) {
            TSpecCheck tc = new TSpecCheck();
            tc.setDevType(4l);
            tc.setCheckUnit(tSpecdevGl.getCheckUnit());
            tc.setDevId(tSpecdevGl.getId());
            tc.setNextWarnDate(tSpecdevGl.getNextWarnDate());
            tc.setReportNo(tSpecdevGl.getReportNo());
            tc.setWarnDate(tSpecdevGl.getWarnDate());
            tc.setOutWarnDate(tSpecdevGl.getOutWarnDate());
            tc.setOutReportNo(tSpecdevGl.getOutReportNo());
            tc.setOutCheckConclusion(tSpecdevGl.getOutCheckConclusion());
            tc.setOutNextWarnDate(tSpecdevGl.getOutNextWarnDate());
            tSpecCheckService.insertTSpecCheck(tc);
        }
        return toAjax(tSpecdevGlService.updateTSpecdevGl(tSpecdevGl));
    }

    /**
     * 删除特种设备锅炉台账
     */
    @PreAuthorize("@ss.hasPermi('sems:specGl:remove')")
    @Log(title = "特种设备锅炉台账", businessType = BusinessType.DELETE)
	@DeleteMapping("/{ids}")
    public AjaxResult remove(@PathVariable Long[] ids)
    {
        return toAjax(tSpecdevGlService.deleteTSpecdevGlByIds(ids));
    }

    /**
     * 去重
     */
    @PreAuthorize("@ss.hasPermi('sems:plant:remove')")
    @GetMapping("/duplicate")
    public AjaxResult duplicate()
    {
        tSpecdevGlService.duplicateTSpecdevGl();
        return AjaxResult.success();
    }

    /**
     * 批量导入
     */
    @PreAuthorize("@ss.hasPermi('sems:specGl:add')")
    @Log(title = "特种设备批量导入", businessType = BusinessType.INSERT)
    @PostMapping("/importData")
    public AjaxResult importData(@RequestParam("file") MultipartFile file) throws IOException
    {
        //获取操作人员ID
        Long userId = getUserId();
        //报错行数统计
        List<Integer> failRow =new ArrayList<Integer>();
        Workbook workbook = ExcelUtils.getWorkBook(file);
        Sheet sheet = workbook.getSheetAt(0);
        List<TSpecdevGl> list = new ArrayList<TSpecdevGl>();
        //字典查询
        List<SysDictData> plant = iSysDictTypeService.selectDictDataByType("PLANT_DIVIDE");

        //部门查询
        List<SysDept> dept = iSysDeptService.selectDeptList(new SysDept());
        int rowNum = sheet.getPhysicalNumberOfRows();
        int failNumber = 0;
        for (int i = 1; i < rowNum; i++) {
            try {
                logger.info("读取行数：" + i);
                Row row = sheet.getRow(i);
                int cellNum = row.getLastCellNum();
                TSpecdevGl entity = new TSpecdevGl();
                for (int j = 0; j < cellNum; j++) {
                    Cell cell = row.getCell(j);
                    if (cell == null) {
                        continue;
                    }
                    String cellValue = ExcelUtils.getCellValue(cell);
                    logger.info("cellValue:" + cellValue);
                    if (j == 0) {
                        //序号
                    } else if (j == 1) {
                        entity.setPlantCode(cellValue);//装置名称
                    } else if (j == 2) {
                        entity.setUnit(cellValue);//单元
                    } else if (j == 3) {
                        entity.setPlantMaint(cellValue);//装置维修组
                    } else if (j == 4) {
                        entity.setEngineer(cellValue);//装置维修工程师
                    } else if (j == 5) {
                        entity.setDevno(cellValue);//位号
                    } else if (j == 6) {
                        entity.setDevname(cellValue);//设备名称
                    } else if (j == 7) {
                        entity.setModel(cellValue);//型号
                    } else if (j == 8) {
                        entity.setUseno(cellValue);//使用证号
                    } else if (j == 9) {
                        entity.setRegno(cellValue);//注册编号
                    } else if (j == 10) {
                        entity.setCreateUnit(cellValue);//制造单位
                    } else if (j == 11) {
                        entity.setBurnMode(cellValue);//燃烧方式
                    } else if (j == 12) {
                        entity.setWaterMode(cellValue);//水处理方式
                    } else if (j == 13) {
                        entity.setBurnKind(cellValue);//燃烧种类
                    } else if (j == 14) {
                        entity.setRatedPower(cellValue);//额定出力
                    } else if (j == 15) {
                        entity.setDesTemp(cellValue);//设计温度
                    } else if (j == 16) {
                        entity.setOptTemp(cellValue);//操作温度
                    } else if (j == 17) {
                        entity.setDesPressure(cellValue);//设计压力
                    } else if (j == 18) {
                        entity.setOptPressure(cellValue);//操作压力
                    } else if (j == 19) {
                        if (cellValue.length() > 3) {//投用日期
                            entity.setSubmitdate(new SimpleDateFormat(DateUtils.getDateFormat(cellValue)).parse(cellValue));
                        }
                    } else if (j == 20) {
                        entity.setCheckUnit(cellValue);//检验单位
                    } else if (j == 21) {
                        if (cellValue.length() > 3) {//本次内部检验日期
                            entity.setWarnDate(new SimpleDateFormat(DateUtils.getDateFormat(cellValue)).parse(cellValue));
                        }
                    } else if (j == 22) {
                        entity.setCheckConclusion(cellValue);//内部检验结论
                    } else if (j == 23) {
                        entity.setReportNo(cellValue);//内部检验报告编号
                    } else if (j == 24) {
                        if (cellValue.length() > 3) {//下次内部检验日期
                            entity.setNextWarnDate(new SimpleDateFormat(DateUtils.getDateFormat(cellValue)).parse(cellValue));
                        }
                    } else if (j == 25) {
                        if (cellValue.length() > 3) {//本次外部检验日期
                            entity.setOutWarnDate(new SimpleDateFormat(DateUtils.getDateFormat(cellValue)).parse(cellValue));
                        }
                    } else if (j == 26) {
                        entity.setOutCheckConclusion(cellValue);//外部检验结论
                    } else if (j == 27) {
                        entity.setOutReportNo(cellValue);//外部检验报告编号
                    } else if (j == 28) {
                        if (cellValue.length() > 3) {//下次外部检验日期
                            entity.setOutNextWarnDate(new SimpleDateFormat(DateUtils.getDateFormat(cellValue)).parse(cellValue));
                        }
                    } else if (j == 29) {
                        entity.setRemarks(cellValue);//备注
                    }/*else if (j == 30) {
                        for (SysDept d : dept) {
                            if (d.getDeptName().equals(cellValue)) {
                                entity.setDeptId(d.getDeptId());//部门编号
                            }
                        }
                    }*/

                }
                entity.setCreaterCode(userId.toString());
                logger.info("entity:" + entity);
                list.add(entity);
            }catch (Exception e){
                failNumber++;
                logger.info("e:" + JSON.toJSONString(e));
                failRow.add(i + 1);
            }
        }
        int successNumber = 0;
        int failNum = 0;
        for (TSpecdevGl t : list
        ) {
            failNum++;
            try {
                tSpecdevGlService.insertTSpecdevGl(t);
                successNumber++;
            }catch (Exception e){
                failNumber++;
                logger.info("e:" + e);
                failRow.add(failNum + 1);
            }
        }
        logger.info("list:" + JSON.toJSONString(list));
        logger.info("successNumber:" +String.valueOf(successNumber));
        logger.info("failNumber:" +String.valueOf(failNumber));
        logger.info("failRow:" +String.valueOf(failRow));
        return AjaxResult.success(String.valueOf(successNumber), failRow);
    }

    /**
     * 批量导入
     * 检验更新导入
     */
    @PreAuthorize("@ss.hasPermi('sems:specGl:add')")
    @Log(title = "特种设备批量导入", businessType = BusinessType.INSERT)
    @PostMapping("/updateData")
    public AjaxResult updateData(@RequestParam("file") MultipartFile file) throws IOException
    {
        //获取操作人员ID
        Long userId = getUserId();
        //报错行数统计
        List<Integer> failRow =new ArrayList<Integer>();
        Workbook workbook = ExcelUtils.getWorkBook(file);
        Sheet sheet = workbook.getSheetAt(0);
        List<TSpecdevGl> list = new ArrayList<TSpecdevGl>();
        List<TSpecdevGl> oldList = new ArrayList<TSpecdevGl>();
        TSpecdevGl oldEntity = new TSpecdevGl();
        //字典查询
        List<SysDictData> plant = iSysDictTypeService.selectDictDataByType("PLANT_DIVIDE");

        //部门查询
        List<SysDept> dept = iSysDeptService.selectDeptList(new SysDept());
        int rowNum = sheet.getPhysicalNumberOfRows();
        int failNumber = 0;
        for (int i = 1; i < rowNum; i++) {
            try {
                logger.info("读取行数：" + i);
                Row row = sheet.getRow(i);
                int cellNum = row.getLastCellNum();
                TSpecdevGl entity = new TSpecdevGl();
                for (int j = 0; j < cellNum; j++) {
                    Cell cell = row.getCell(j);
                    if (cell == null) {
                        continue;
                    }
                    String cellValue = ExcelUtils.getCellValue(cell);
                    logger.info("cellValue:" + cellValue);

                    if (j == 0) {
                        //序号
                        Double d = Double.parseDouble(cellValue);
                        long s = new Double(d).longValue();
                        entity.setId(s);
                    } else if (j == 1) {
                        entity.setPlantCode(cellValue);//装置名称
                    } else if (j == 2) {
                        entity.setDevno(cellValue);//位号
                    } else if (j == 3) {
                        entity.setDevname(cellValue);//设备名称
                    } else if (j == 4) {
                        entity.setUseno(cellValue);//使用证号
                    } else if (j == 5) {
                        entity.setCheckUnit(cellValue);//检验单位
                    } else if (j == 6) {
                        logger.info("日期格式：" + cellValue);
                        if (cellValue.length() > 3) {//本次内部检验日期
                            entity.setWarnDate(new SimpleDateFormat(DateUtils.getDateFormat(cellValue)).parse(cellValue));
                        }
                    } else if (j == 7) {
                        entity.setCheckConclusion(cellValue);//内部检验结论
                    } else if (j == 8) {
                        entity.setReportNo(cellValue);//内部检验报告编号
                    } else if (j == 9) {
                        logger.info("日期格式：" + cellValue);
                        if (cellValue.length() > 3) {//下次内部检验日期
                            entity.setNextWarnDate(new SimpleDateFormat(DateUtils.getDateFormat(cellValue)).parse(cellValue));
                        }
                    } else if (j == 10) {
                        logger.info("日期格式：" + cellValue);
                        if (cellValue.length() > 3) {//本次外部检验日期
                            entity.setOutWarnDate(new SimpleDateFormat(DateUtils.getDateFormat(cellValue)).parse(cellValue));
                        }
                    } else if (j == 11) {
                        entity.setOutCheckConclusion(cellValue);//外部检验结论
                    } else if (j == 12) {
                        entity.setOutReportNo(cellValue);//外部检验报告编号
                    } else if (j == 13) {
                        logger.info("日期格式：" + cellValue);
                        if (cellValue.length() > 3) {//下次外部检验日期
                            entity.setOutNextWarnDate(new SimpleDateFormat(DateUtils.getDateFormat(cellValue)).parse(cellValue));
                        }
                    }
                }
                logger.info("entity:" + JSON.toJSONString(entity));
                list.add(entity);
                oldEntity = entity;
                oldList.add(oldEntity);
            }catch (Exception e){
                failNumber++;
                logger.info("e:" + JSON.toJSONString(e));
                failRow.add(i + 1);
            }
        }
        int successNumber = 0;
        int failNum = 0;
        for (TSpecdevGl t : list) {
            failNum++;
            try {
                tSpecdevGlService
                        .update(t,
                                new QueryWrapper<TSpecdevGl>()
                                        .eq("USENO", t.getUseno())
                                        .eq("PLANT_CODE", t.getPlantCode())
                                        .eq("DEVNO" , t.getDevno())
                        );
                successNumber++;
            }catch (Exception e){
                failNumber++;
                logger.info("e:" + e);
                failRow.add(failNum + 1);
                e.printStackTrace();
            }
        }

        for (TSpecdevGl t : oldList) {
            TSpecCheck tc = new TSpecCheck();
            tc.setDevType(4l);
            tc.setCheckUnit(t.getCheckUnit());
            tc.setDevId(t.getId());
            tc.setNextWarnDate(t.getNextWarnDate());
            tc.setReportNo(t.getReportNo());
            tc.setWarnDate(t.getWarnDate());
            tc.setOutWarnDate(t.getOutWarnDate());
            tc.setOutReportNo(t.getOutReportNo());
            tc.setOutCheckConclusion(t.getOutCheckConclusion());
            tc.setOutNextWarnDate(t.getOutNextWarnDate());
            tSpecCheckService.insertTSpecCheck(tc);
        }
        logger.info("list:" + JSON.toJSONString(list));
        logger.info("successNumber:" +String.valueOf(successNumber));
        logger.info("failNumber:" +String.valueOf(failNumber));
        logger.info("failRow:" +String.valueOf(failRow));
        return AjaxResult.success(String.valueOf(successNumber), failRow);
    }

    @GetMapping("/exportDevList")
    public AjaxResult exportbmy(ParamData params) throws IOException {
        logger.info(JSON.toJSONString(params));
        String id = params.getIds();
        String[] ids = id.split(",");
        List<TSpecdevGl> list = new ArrayList<>();
        for (String i : ids
        ) {
            TSpecdevGl t = tSpecdevGlService.getById(i);
            list.add(t);
        }
        SXSSFWorkbook wb = new SXSSFWorkbook(1000);
        CellStyle wrapStyle = wb.createCellStyle();
        wrapStyle.setWrapText(true);    //设置自动换行
        //创建sheet页
        Sheet sheet = wb.createSheet("sheet1");
        //设置列的宽度，第一个参数为列的序号，从0开始，第二参数为列宽，单位1/256个字节
        sheet.setColumnWidth(0, 12*256);
        sheet.setColumnWidth(1, 26*256);
        sheet.setColumnWidth(2, 26*256);
        sheet.setColumnWidth(3, 26*256);
        sheet.setColumnWidth(4, 26*256);
        sheet.setColumnWidth(5, 26*256);
        sheet.setColumnWidth(6, 26*256);
        sheet.setColumnWidth(7, 26*256);
        sheet.setColumnWidth(8, 40*256);
        sheet.setColumnWidth(9, 40*256);
        sheet.setColumnWidth(10, 26*256);
        sheet.setColumnWidth(11, 26*256);
        sheet.setColumnWidth(12, 40*256);
        sheet.setColumnWidth(13, 40*256);
        //设置开始行和开始列

        Row row0 = sheet.createRow(0);
        CellStyle style = wb.createCellStyle();
        style.setFillForegroundColor(IndexedColors.YELLOW.getIndex());
        style.setFillPattern(FillPatternType.SOLID_FOREGROUND);
//        Font headerFont = wb.createFont();
//        headerFont.setFontName("Arial");
//        headerFont.setFontHeightInPoints((short) 12);
//        headerFont.setBold(false);
//        headerFont.setColor(IndexedColors.BLACK.getIndex());
//        style.setFont(headerFont);
        Cell cell0 = row0.createCell(0);
        row0.createCell(0).setCellValue("序号");
        row0.createCell(1).setCellValue("装置");
        row0.createCell(2).setCellValue("设备位号");
        row0.createCell(3).setCellValue("设备名称");
        row0.createCell(4).setCellValue("使用证号码");
        row0.createCell(5).setCellValue("检验单位");row0.getCell(5).setCellStyle(style);
        row0.createCell(6).setCellValue("本次内部检验日期");row0.getCell(6).setCellStyle(style);
        row0.createCell(7).setCellValue("内部检验结论");row0.getCell(7).setCellStyle(style);
        row0.createCell(8).setCellValue("内部检验报告编号");row0.getCell(8).setCellStyle(style);
        row0.createCell(9).setCellValue("下次内部检验日期");row0.getCell(9).setCellStyle(style);

        row0.createCell(10).setCellValue("本次外部检验日期");row0.getCell(10).setCellStyle(style);
        row0.createCell(11).setCellValue("外部检验结论");row0.getCell(11).setCellStyle(style);
        row0.createCell(12).setCellValue("外部检验报告编号");row0.getCell(12).setCellStyle(style);
        row0.createCell(13).setCellValue("下次外部检验日期");row0.getCell(13).setCellStyle(style);

        //填充数据
        int rowIndex = 1;
        int columnIndex = 1;
        for (TSpecdevGl t: list
        ) {
            Row row = sheet.createRow(rowIndex);
            row.createCell(0).setCellValue(t.getId());
            row.createCell(1).setCellValue(t.getPlantCode());
            row.createCell(2).setCellValue(t.getDevno());
            row.createCell(3).setCellValue(t.getDevname());
            row.createCell(4).setCellValue(t.getUseno());
            row.createCell(5).setCellValue(t.getCheckUnit());
            if (t.getWarnDate()!= null){
                row.createCell(6).setCellValue(new SimpleDateFormat("yyyy-MM-dd").format(t.getWarnDate()));
            }

            row.createCell(7).setCellValue(t.getCheckConclusion());
            row.createCell(8).setCellValue(t.getReportNo());
            if (t.getNextWarnDate()!= null){
                row.createCell(9).setCellValue(new SimpleDateFormat("yyyy-MM-dd").format(t.getNextWarnDate()));
            }
            if (t.getOutWarnDate()!= null){
                row.createCell(10).setCellValue(new SimpleDateFormat("yyyy-MM-dd").format(t.getOutWarnDate()));
            }
            row.createCell(11).setCellValue(t.getOutCheckConclusion());
            row.createCell(12).setCellValue(t.getOutReportNo());
            if (t.getOutNextWarnDate()!= null){
                row.createCell(13).setCellValue(new SimpleDateFormat("yyyy-MM-dd").format(t.getOutNextWarnDate()));
            }
            rowIndex++;
        }
        OutputStream out = null;
        String filename = ExcelUtil.encodingFilename("锅炉批量更新");
        out = new FileOutputStream(ExcelUtil.getAbsoluteFile(filename));
        wb.write(out);
        wb.close();
        out.close();
        return AjaxResult.success(filename);
    }
}
